/*
	RT Bench - Benchmarks various hash functions for Rainbow Tables
	Copyright (C) 2012 Steve Thomas <steve AT tobtu DOT com>

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#define AVX_CODE

#include "mysqlsha1.h"
#include "sha1.h"
#include "sha1help.h"

// ***********************
// **** Compile flags ****
// ***********************
// Intel: icl /QxAVX
//        icc -xAVX
// MSVS:  /arch:AVX
// GCC:   -mavx

#ifdef ARC_x86

void MySQLSHA1::calcAVX(vector4 *pw, vector4 *hash)
{
	SHA1::calcAVX(pw, hash + __SHA1_INTERLACED__);
	if (__SHA1_INTERLACED__ > 0) { ((__m128i*) hash)[0 * __SHA1_INTERLACED__ + 0] = _mm_set1_epi32(20); }
	if (__SHA1_INTERLACED__ > 1) { ((__m128i*) hash)[0 * __SHA1_INTERLACED__ + 1] = _mm_set1_epi32(20); }
	if (__SHA1_INTERLACED__ > 2) { ((__m128i*) hash)[0 * __SHA1_INTERLACED__ + 2] = _mm_set1_epi32(20); }
	if (__SHA1_INTERLACED__ > 0) { ((__m128i*) hash)[6 * __SHA1_INTERLACED__ + 0] = _mm_set1_epi32(0x80); }
	if (__SHA1_INTERLACED__ > 1) { ((__m128i*) hash)[6 * __SHA1_INTERLACED__ + 1] = _mm_set1_epi32(0x80); }
	if (__SHA1_INTERLACED__ > 2) { ((__m128i*) hash)[6 * __SHA1_INTERLACED__ + 2] = _mm_set1_epi32(0x80); }
	SHA1::calcAVX(hash, hash);
}

#endif
